vec2 random2(vec2 st)
{
    vec2 s = vec2(dot(st, vec2(12.3456, 34.1415)),
                  dot(st, vec2(42.2154, 15.2854)));
    return fract(sin(s) * 45678.9) * 2.0 - 1.0;
}

float secondClosestCellularNoise(vec2 st)
{
    ivec2 cell = ivec2(floor(st));
    vec2 f = st - vec2(cell);

    float minDist = 1.0;
    float secondDist = 1.0;

    for (int y = -1; y <= 1; y++)
    {
        for (int x = -1; x <= 1; x++)
        {
            ivec2 localCell = cell + ivec2(x, y);
            vec2 localPoint = random2(vec2(localCell)) * 0.5 + 0.5 + vec2(x, y);
            float dist = length(localPoint - f);
            // Tady je třeba dát pozor na pořadí podmínek
            if (dist < secondDist && dist > minDist)
            {
                // Vzdálenost k aktuálnímu bodu je mezi
                // dosavadním prvním a druhým nejbližším
                secondDist = dist;
            }
            
            if (dist < minDist)
            {
                // Aktuální je blíž než nejbližší
                secondDist = minDist;
                minDist = dist;
            }
        }
    }

    // Vrátíme druhý nejbližší
    return secondDist;
}

void mainImage(out vec4 fragColor, in vec2 fragCoord)
{
    vec2 uv = fragCoord/iResolution.xy;
    // Střed souřadnic chceme uprostřed obrazu
    uv = uv * 2.0 - 1.0;
    // Korekce pro správný poměr stran
    uv.x *= iResolution.x / iResolution.y;

    vec3 col = vec3(secondClosestCellularNoise(uv * 4.0));

    fragColor = vec4(col, 1.0);
}
